Index: branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90
===================================================================
--- branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 6638)
+++ branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 6639)
@@ -16,4 +16,7 @@
    !!  -   !  2013-05  (A. Yool)              updated for v3.5
    !!  -   !  2014-08  (A. Yool, J. Palm)     Add DMS module for UKESM1 model
+   !!  -   !  2015-06  (A. Yool)              Update to include MOCSY
+   !!  -   !  2015-07  (A. Yool)              Update for rolling averages
+   !!  -   !  2015-10  (J. Palm)              Update for diag outputs through iom_use  
    !!----------------------------------------------------------------------
    !!
@@ -36,4 +39,17 @@
 #endif
    !!
+#if defined key_mocsy
+   !!----------------------------------------------------------------------
+   !! Updates with the addition of MOCSY include:
+   !!   - option to use PML or MOCSY carbonate chemistry (the latter is 
+   !!     preferred)
+   !!   - central calculation of gas transfer velocity, f_kw660; previously
+   !!     this was done separately for CO2 and O2 with predictable results
+   !!   - distribution of f_kw660 to both PML and MOCSY CO2 air-sea flux 
+   !!     calculations and to those for O2 air-sea flux
+   !!   - extra diagnostics included for MOCSY
+   !!----------------------------------------------------------------------
+#endif
+   !!
 #if defined key_medusa
    !!----------------------------------------------------------------------
@@ -53,7 +69,14 @@
 # if defined key_iomput
       USE iom
+      USE trcnam_medusa         ! JPALM 13-11-2015 -- if iom_use for diag
+      !!USE trc_nam_iom_medusa  ! JPALM 13-11-2015 -- if iom_use for diag
 # endif
 # if defined key_roam
+      USE gastransfer
+#  if defined key_mocsy
+      USE mocsy_wrapper
+#  else
       USE trcco2_medusa
+#  endif
       USE trcoxy_medusa
       !! Jpalm (08/08/2014)
@@ -134,4 +157,7 @@
       REAL(wp) ::    ztmp, zsal
 # endif
+# if defined key_mocsy
+      REAL(wp) ::    zpho
+# endif
       !!
       !! integrated source and sink terms
@@ -142,6 +168,6 @@
       !!
       !! primary production and chl related quantities      
-      REAL(wp) ::    fthetan,faln,fchn1,fchn,fjln,fprn,frn
-      REAL(wp) ::    fthetad,fald,fchd1,fchd,fjld,fprd,frd
+      REAL(wp)                     ::    fthetan,faln,fchn1,fchn,fjln,fprn,frn
+      REAL(wp)                     ::    fthetad,fald,fchd1,fchd,fjld,fprd,frd
       !! AXY (03/02/11): add in Liebig terms
       REAL(wp) ::    fpnlim, fpdlim
@@ -150,5 +176,5 @@
       INTEGER  ::    ieppley
       !! AXY (01/03/10): add in mixed layer PP diagnostics
-      REAL(wp) ::    fprn_ml,fprd_ml
+      REAL(wp), DIMENSION(jpi,jpj) ::  fprn_ml,fprd_ml
       !!
       !! nutrient limiting factors
@@ -161,5 +187,6 @@
       !! iron cycle; includes parameters for Parekh et al. (2005) iron scheme
       REAL(wp) ::    ffetop,ffebot,ffescav
-      REAL(wp) ::    xLgF, xFeT, xFeF, xFeL, xFree  !! state variables for iron-ligand system
+      REAL(wp) ::    xLgF, xFeT, xFeF, xFeL         !! state variables for iron-ligand system
+      REAL(wp), DIMENSION(jpi,jpj) ::  xFree        !! state variables for iron-ligand system
       REAL(wp) ::    xb_coef_tmp, xb2M4ac           !! iron-ligand parameters
       REAL(wp) ::    xmaxFeF,fdeltaFe               !! max Fe' parameters
@@ -189,6 +216,6 @@
 # endif
       REAL(wp) ::    fdpn2,fdpd2,fdpds2,fdzmi2,fdzme2
-      REAL(wp) ::    fslown, fslownflux
-      REAL(wp) ::    fslowc, fslowcflux
+      REAL(wp) ::    fslown, fslowc
+      REAL(wp), DIMENSION(jpi,jpj) ::    fslownflux, fslowcflux
       REAL(wp) ::    fregen,fregensi
       REAL(wp), DIMENSION(jpi,jpj) ::    fregenfast,fregenfastsi
@@ -206,5 +233,5 @@
       REAL(wp) ::    fheren,fheresi,fherefe,fherec,fhereca
       REAL(wp) ::    fprotf
-      REAL(wp) ::    fsedn,fsedsi,fsedfe,fsedc,fsedca
+      REAL(wp), DIMENSION(jpi,jpj) ::    fsedn,fsedsi,fsedfe,fsedc,fsedca
       REAL(wp), DIMENSION(jpi,jpj) ::    fccd
       REAL(wp) ::    fccd_dep
@@ -226,10 +253,10 @@
       !!
       !! water column nutrient and flux integrals
-      REAL(wp) ::    ftot_n,ftot_si,ftot_fe
+      REAL(wp), DIMENSION(jpi,jpj) ::    ftot_n,ftot_si,ftot_fe
       REAL(wp), DIMENSION(jpi,jpj) ::    fflx_n,fflx_si,fflx_fe
       REAL(wp), DIMENSION(jpi,jpj) ::    fifd_n,fifd_si,fifd_fe
       REAL(wp), DIMENSION(jpi,jpj) ::    fofd_n,fofd_si,fofd_fe
 # if defined key_roam
-      REAL(wp) ::    ftot_c,ftot_a,ftot_o2
+      REAL(wp), DIMENSION(jpi,jpj) ::    ftot_c,ftot_a,ftot_o2
       REAL(wp), DIMENSION(jpi,jpj) ::    fflx_c,fflx_a,fflx_o2
       REAL(wp), DIMENSION(jpi,jpj) ::    fifd_c,fifd_a,fifd_o2
@@ -266,4 +293,9 @@
       REAL(wp) ::    f_kw660, f_o2flux, f_o2sat
       REAL(wp), DIMENSION(jpi,jpj) ::    f_omcal, f_omarg
+      !!
+      !! AXY (23/06/15): additional diagnostics for MOCSY and oxygen
+      REAL(wp) ::    f_fco2w, f_BetaD, f_rhosw, f_opres, f_insitut, f_pco2atm, f_fco2atm
+      REAL(wp) ::    f_schmidtco2, f_kwco2, f_K0, f_co2starair, f_dpco2, f_kwo2
+      !!
       INTEGER  ::    iters
       REAL(wp) ::    f_year
@@ -273,5 +305,5 @@
       !! carbon, alkalinity production and consumption
       REAL(wp) ::    fc_prod, fc_cons, fa_prod, fa_cons
-      REAL(wp) ::    fcomm_resp
+      REAL(wp), DIMENSION(jpi,jpj) ::    fcomm_resp
       REAL(wp), DIMENSION(jpi,jpj) ::    fcar_prod, fcar_cons
       !!
@@ -303,6 +335,35 @@
       !! horizontal grid location
       REAL(wp) ::    flatx, flonx
-
+      !!
+      !! Jpalm -- 11-10-2015 -- adapt diag to iom_use
+      !! 2D var for diagnostics.
+      REAL(wp), POINTER, DIMENSION(:,:  ) :: fprn2d, fdpn2d, fprd2d, fdpd2d, fprds2d, fsdiss2d, fgmipn2d
+      REAL(wp), POINTER, DIMENSION(:,:  ) :: fgmid2d, fdzmi2d, fgmepn2d, fgmepd2d, fgmezmi2d, fgmed2d
+      REAL(wp), POINTER, DIMENSION(:,:  ) :: fdzme2d, fslown2d, fdd2d, ffetop2d, ffebot2d, ffescav2d
+      REAL(wp), POINTER, DIMENSION(:,:  ) :: fjln2d, fnln2d, ffln2d, fjld2d, fnld2d, ffld2d, fsld2d2
+      REAL(wp), POINTER, DIMENSION(:,:  ) :: fsld2d, fregen2d, fregensi2d, ftempn2d, ftempsi2d, ftempfe2d
+      REAL(wp), POINTER, DIMENSION(:,:  ) :: ftempc2d, ftempca2d, freminn2d, freminsi2d, freminfe2d
+      REAL(wp), POINTER, DIMENSION(:,:  ) :: freminc2d, freminca2d
+      REAL(wp), POINTER, DIMENSION(:,:  ) :: zw2d
+# if defined key_roam
+      REAL(wp), POINTER, DIMENSION(:,:  ) :: ffastca2d, rivn2d, rivsi2d, rivc2d, rivalk2d, fslowc2d
+      REAL(wp), POINTER, DIMENSION(:,:  ) :: fdpn22d, fdpd22d, fdzmi22d, fdzme22d, zimesn2d, zimesd2d
+      REAL(wp), POINTER, DIMENSION(:,:  ) :: zimesc2d, zimesdc2d, ziexcr2d, ziresp2d, zigrow2d, zemesn2d
+      REAL(wp), POINTER, DIMENSION(:,:  ) :: zemesd2d, zemesc2d, zemesdc2d, zeexcr2d, zeresp2d, zegrow2d
+      REAL(wp), POINTER, DIMENSION(:,:  ) :: mdetc2d, gmidc2d, gmedc2d, f_pco2a2d, f_pco2w2d, f_co2flux2d
+      REAL(wp), POINTER, DIMENSION(:,:  ) :: f_TDIC2d, f_TALK2d, f_kw6602d, f_pp02d, f_o2flux2d, f_o2sat2d
+      REAL(wp), POINTER, DIMENSION(:,:  ) :: dms_surf2d, dms_andr2d, dms_simo2d, dms_aran2d, dms_hall2d
+      REAL(wp), POINTER, DIMENSION(:,:  ) :: iben_n2d, iben_fe2d, iben_c2d, iben_si2d, iben_ca2d, oben_n2d
+      REAL(wp), POINTER, DIMENSION(:,:  ) :: oben_fe2d, oben_c2d, oben_si2d, oben_ca2d, sfr_ocal2d
+      REAL(wp), POINTER, DIMENSION(:,:  ) :: sfr_oarg2d, lyso_ca2d 
+# endif
+      !! 2D var for diagnostics.
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: tpp3d, detflux3d, remin3dn
       !!---------------------------------------------------------------------
+
+# if defined key_debug_medusa
+      IF (lwp) write (numout,*) 'trc_bio_medusa: variables defined'
+      CALL flush(numout)
+# endif 
 
       !! AXY (20/11/14): alter this to report on first MEDUSA call
@@ -376,4 +437,10 @@
       ffastc(:,:)  = 0.0        !! organic carbon
       ffastca(:,:) = 0.0        !! biogenic calcium carbonate
+      !!
+      fsedn(:,:)   = 0.0        !! Seafloor flux of N 
+      fsedsi(:,:)  = 0.0        !! Seafloor flux of Si
+      fsedfe(:,:)  = 0.0        !! Seafloor flux of Fe
+      fsedc(:,:)   = 0.0        !! Seafloor flux of C
+      fsedca(:,:)  = 0.0        !! Seafloor flux of CaCO3
       !!
       fregenfast(:,:)   = 0.0   !! integrated  N regeneration (fast detritus)
@@ -402,4 +469,7 @@
       fflx_a(:,:)  = 0.0        !! alkalinity flux total
       fflx_o2(:,:) = 0.0        !! oxygen     flux total
+      ftot_c(:,:)  = 0.0        !! carbon     inventory
+      ftot_a(:,:)  = 0.0        !! alkalinity inventory
+      ftot_o2(:,:) = 0.0        !! oxygen     inventory
       fifd_c(:,:)  = 0.0        !! carbon     fast detritus production
       fifd_a(:,:)  = 0.0        !! alkalinity fast detritus production
@@ -420,4 +490,7 @@
       foxy_anox(:,:) = 0.0      !! unrealised oxygen consumption
 # endif
+      ftot_n(:,:)   = 0.0       !! N inventory 
+      ftot_si(:,:)  = 0.0       !! Si inventory
+      ftot_fe(:,:)  = 0.0       !! Fe inventory
       ftot_pn(:,:)  = 0.0       !! integrated non-diatom phytoplankton
       ftot_pd(:,:)  = 0.0       !! integrated diatom     phytoplankton
@@ -454,5 +527,410 @@
       f_riv_c(:,:)   = 0.0      !! riverine C   input 
       f_riv_alk(:,:) = 0.0      !! riverine alk input 
-
+      !!
+      !! allocate and initiate 2D diag
+      !! -----------------------------
+      !! Juju :: add kt condition !!
+      IF( lk_iomput .AND. .NOT.  ln_diatrc ) THEN 
+      !!
+      if ( kt == nittrc000 )   CALL trc_nam_iom_medusa !! initialise iom_use test
+      !!
+      CALL wrk_alloc( jpi, jpj,      zw2d )
+      zw2d(:,:)      = 0.0      !!
+      IF ( med_diag%PRN%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   fprn2d    )
+         fprn2d(:,:)      = 0.0      !!
+      ENDIF
+      IF ( med_diag%MPN%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   fdpn2d    )
+         fdpn2d(:,:)      = 0.0      !!
+      ENDIF
+      IF ( med_diag%PRD%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   fprd2d    )
+         fprd2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%MPD%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   fdpd2d    )
+         fdpd2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%OPAL%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   fprds2d    )
+         fprds2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%OPALDISS%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   fsdiss2d    )
+         fsdiss2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%GMIPn%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   fgmipn2d    )
+         fgmipn2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%GMID%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   fgmid2d    )
+         fgmid2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%MZMI%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   fdzmi2d    )
+         fdzmi2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%GMEPN%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   fgmepn2d    )
+         fgmepn2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%GMEPD%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   fgmepd2d    )
+         fgmepd2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%GMEZMI%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   fgmezmi2d    )
+         fgmezmi2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%GMED%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   fgmed2d    )
+         fgmed2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%MZME%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   fdzme2d    )
+         fdzme2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%DETN%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   fslown2d    )
+         fslown2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%MDET%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   fdd2d    )
+         fdd2d(:,:)      = 0.0      !!
+      ENDIF      
+      IF( med_diag%AEOLIAN%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   ffetop2d    )
+         ffetop2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%BENTHIC%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    ffebot2d   )
+         ffebot2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%SCAVENGE%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   ffescav2d    )
+         ffescav2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%PN_JLIM%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   fjln2d    )
+         fjln2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%PN_NLIM%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   fnln2d    )
+         fnln2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%PN_FELIM%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   ffln2d    )
+         ffln2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%PD_JLIM%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   fjld2d    )
+         fjld2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%PD_NLIM%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   fnld2d    )
+         fnld2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%PD_FELIM%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   ffld2d    )
+         ffld2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%PD_SILIM%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   fsld2d2    )
+         fsld2d2(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%PDSILIM2%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   fsld2d    )
+         fsld2d(:,:)      = 0.0      !!
+      ENDIF
+      !! 
+      IF( med_diag%TOTREG_N%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   fregen2d    )
+         fregen2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%TOTRG_SI%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   fregensi2d    )
+         fregensi2d(:,:)      = 0.0      !!
+      ENDIF
+                !! 
+      IF( med_diag%FASTN%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   ftempn2d    )
+         ftempn2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%FASTSI%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   ftempsi2d    )
+         ftempsi2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%FASTFE%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,  ftempfe2d     )
+         ftempfe2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%FASTC%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,  ftempc2d     )
+         ftempc2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%FASTCA%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   ftempca2d    )
+         ftempca2d(:,:)      = 0.0      !!
+      ENDIF     
+      !! 
+      IF( med_diag%REMINN%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    freminn2d   )
+         freminn2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%REMINSI%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    freminsi2d   )
+         freminsi2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%REMINFE%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    freminfe2d   )
+         freminfe2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%REMINC%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   freminc2d    )
+         freminc2d(:,:)      = 0.0      !! 
+      ENDIF
+      IF( med_diag%REMINCA%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   freminca2d    )
+         freminca2d(:,:)      = 0.0      !!
+      ENDIF
+# if defined key_roam                  
+      IF( med_diag%RR_0100%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   ffastca2d    )
+         ffastca2d(:,:)      = 0.0      !!
+      ENDIF      
+      IF( med_diag%RIV_N%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    rivn2d   )
+         rivn2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%RIV_SI%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    rivsi2d   )
+         rivsi2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%RIV_C%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   rivc2d    )
+         rivc2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%RIV_ALK%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    rivalk2d   )
+         rivalk2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%DETC%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    fslowc2d   )
+         fslowc2d(:,:)      = 0.0      !!
+      ENDIF 
+      IF( med_diag%PN_LLOSS%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    fdpn22d   )
+         fdpn22d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%PD_LLOSS%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    fdpd22d   )
+         fdpd22d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%ZI_LLOSS%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    fdzmi22d   )
+         fdzmi22d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%ZE_LLOSS%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   fdzme22d    )
+         fdzme22d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%ZI_MES_N%dgsave ) THEN   
+         CALL wrk_alloc( jpi, jpj,   zimesn2d    )
+         zimesn2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%ZI_MES_D%dgsave ) THEN
+      CALL wrk_alloc( jpi, jpj,    zimesd2d   )
+         zimesd2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%ZI_MES_C%dgsave ) THEN
+      CALL wrk_alloc( jpi, jpj,    zimesc2d   )
+         zimesc2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%ZI_MESDC%dgsave ) THEN
+      CALL wrk_alloc( jpi, jpj,    zimesdc2d   )
+         zimesdc2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%ZI_EXCR%dgsave ) THEN
+      CALL wrk_alloc( jpi, jpj,     ziexcr2d  )
+         ziexcr2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%ZI_RESP%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    ziresp2d   )
+         ziresp2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%ZI_GROW%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    zigrow2d   )
+         zigrow2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%ZE_MES_N%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   zemesn2d    )
+         zemesn2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%ZE_MES_D%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    zemesd2d   )
+         zemesd2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%ZE_MES_C%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    zemesc2d   )
+         zemesc2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%ZE_MESDC%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    zemesdc2d   )
+         zemesdc2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%ZE_EXCR%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    zeexcr2d   )
+         zeexcr2d(:,:)      = 0.0      !!
+      ENDIF                  
+      IF( med_diag%ZE_RESP%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    zeresp2d   )
+         zeresp2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%ZE_GROW%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    zegrow2d   )
+         zegrow2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%MDETC%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   mdetc2d    )
+         mdetc2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%GMIDC%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    gmidc2d   )
+         gmidc2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%GMEDC%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    gmedc2d   )
+         gmedc2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%ATM_PCO2%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    f_pco2a2d   )
+         f_pco2a2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%OCN_PCO2%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    f_pco2w2d   )
+         f_pco2w2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%CO2FLUX%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    f_co2flux2d   )
+         f_co2flux2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%TCO2%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   f_TDIC2d    )
+         f_TDIC2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%TALK%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    f_TALK2d   )
+         f_TALK2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%KW660%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    f_kw6602d   )
+         f_kw6602d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%ATM_PP0%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    f_pp02d   )
+         f_pp02d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%O2FLUX%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   f_o2flux2d    )
+         f_o2flux2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%O2SAT%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    f_o2sat2d   )
+         f_o2sat2d(:,:)      = 0.0      !!
+      ENDIF 
+      !!
+      IF( med_diag%IBEN_N%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    iben_n2d  )
+         iben_n2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%IBEN_FE%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   iben_fe2d   )
+         iben_fe2d(:,:)      = 0.0     !!
+      ENDIF
+      IF( med_diag%IBEN_C%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   iben_c2d   )
+         iben_c2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%IBEN_SI%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   iben_si2d   )
+         iben_si2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%IBEN_CA%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,   iben_ca2d   )
+         iben_ca2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%OBEN_N%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    oben_n2d  )
+         oben_n2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%OBEN_FE%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    oben_fe2d  )
+         oben_fe2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%OBEN_C%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    oben_c2d  )
+         oben_c2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%OBEN_SI%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    oben_si2d  )
+         oben_si2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%OBEN_CA%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    oben_ca2d  )
+         oben_ca2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%SFR_OCAL%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    sfr_ocal2d  )
+         sfr_ocal2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%SFR_OARG%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    sfr_oarg2d  )
+         sfr_oarg2d(:,:)      = 0.0      !!
+      ENDIF
+      IF( med_diag%LYSO_CA%dgsave ) THEN
+         CALL wrk_alloc( jpi, jpj,    lyso_ca2d  )
+         lyso_ca2d(:,:)      = 0.0      !!
+      ENDIF
+      !!  
+      IF (jdms .eq. 1) THEN
+         IF( med_diag%DMS_SURF%dgsave ) THEN
+            CALL wrk_alloc( jpi, jpj,  dms_surf2d     )
+         dms_surf2d(:,:)      = 0.0      !!
+         ENDIF
+         IF( med_diag%DMS_ANDR%dgsave ) THEN
+            CALL wrk_alloc( jpi, jpj,   dms_andr2d    )
+         dms_andr2d(:,:)      = 0.0      !!
+         ENDIF
+         IF( med_diag%DMS_SIMO%dgsave ) THEN
+            CALL wrk_alloc( jpi, jpj,  dms_simo2d     )
+         dms_simo2d(:,:)      = 0.0      !!
+         ENDIF
+         IF( med_diag%DMS_ARAN%dgsave ) THEN
+            CALL wrk_alloc( jpi, jpj,   dms_aran2d    )
+         dms_aran2d(:,:)      = 0.0      !!
+         ENDIF
+         IF( med_diag%DMS_HALL%dgsave ) THEN
+            CALL wrk_alloc( jpi, jpj,   dms_hall2d    )
+         dms_hall2d(:,:)      = 0.0      !!
+         ENDIF
+      ENDIF   
+# endif  
+         IF( med_diag%TPP3%dgsave ) THEN
+             CALL wrk_alloc( jpi, jpj, jpk,       tpp3d )
+             tpp3d(:,:,:)      = 0.0  !! 
+         ENDIF
+         IF( med_diag%DETFLUX3%dgsave ) THEN
+             CALL wrk_alloc( jpi, jpj, jpk,        detflux3d )
+             detflux3d(:,:,:)      = 0.0  !! 
+         ENDIF
+          IF( med_diag%REMIN3N%dgsave ) THEN
+             CALL wrk_alloc( jpi, jpj, jpk,        remin3dn )
+             remin3dn(:,:,:)      = 0.0  !! 
+          ENDIF
+      ENDIF
+      !! lk_iomput                                   
+      !!
 # if defined key_axy_nancheck
       DO jn = 1,jptra
@@ -486,4 +964,9 @@
 # endif
 
+# if defined key_debug_medusa
+      IF (lwp) write (numout,*) 'trc_bio_medusa: variables initialised and checked'
+      CALL flush(numout)
+# endif 
+
 # if defined key_roam
       !!----------------------------------------------------------------------
@@ -514,8 +997,8 @@
          f_pco2a = fq4
       endif
-# if defined key_axy_pi_co2
-      f_pco2a = hist_pco2(1)
-      IF(lwp) WRITE(numout,*) ' MEDUSA atm pCO2  = FIXED'
-# endif
+#  if defined key_axy_pi_co2
+      !! f_pco2a = hist_pco2(1)
+      f_pco2a = 284.725          !! OCMIP pre-industrial pCO2
+#  endif
       !! IF(lwp) WRITE(numout,*) ' MEDUSA nyear     =', nyear
       !! IF(lwp) WRITE(numout,*) ' MEDUSA nsec_day  =', real(nsec_day)
@@ -529,8 +1012,17 @@
 # endif
 
+# if defined key_debug_medusa
+      IF (lwp) write (numout,*) 'trc_bio_medusa: ready for carbonate chemistry'
+      IF (lwp) write (numout,*) 'trc_bio_medusa: kt = ', kt
+      IF (lwp) write (numout,*) 'trc_bio_medusa: nittrc000 = ', nittrc000
+      CALL flush(numout)
+# endif 
+
 # if defined key_roam
-      !! AXY (20/11/14): alter to call on first MEDUSA timestep
+      !! AXY (20/11/14): alter to call on first MEDUSA timestep and then every
+      !!                 month (this is hardwired as 960 timesteps but should
+      !!                 be calculated and done properly
       !! IF( kt == nit000 .or. mod(kt,1920) == 0 ) THEN
-      IF( kt == nittrc000 .or. mod(kt,1920) == 0 ) THEN
+      IF( kt == nittrc000 .or. mod(kt,960) == 0 ) THEN
          !!----------------------------------------------------------------------
          !! Calculate the carbonate chemistry for the whole ocean on the first
@@ -540,4 +1032,5 @@
          !!
          IF(lwp) WRITE(numout,*) ' MEDUSA calculating all carbonate chemistry at kt =', kt
+         CALL flush(numout)
          !! blank flags
          i2_omcal(:,:) = 0
@@ -549,6 +1042,8 @@
                   !! OPEN wet point IF..THEN loop
                   if (tmask(ji,jj,jk).eq.1) then
-                     !! carbonate chemistry
+                     !! do carbonate chemistry
+                     !!
                      fdep2 = fsdept(ji,jj,jk)           !! set up level midpoint
+                     !!
                      !! set up required state variables
                      zdic = max(0.,trn(ji,jj,jk,jpdic)) !! dissolved inorganic carbon
@@ -556,4 +1051,8 @@
                      ztmp = tsn(ji,jj,jk,jp_tem)        !! temperature
                      zsal = tsn(ji,jj,jk,jp_sal)        !! salinity
+#  if defined key_mocsy
+                     zsil = max(0.,trn(ji,jj,jk,jpsil))        !! silicic acid
+                     zpho = max(0.,trn(ji,jj,jk,jpdin)) / 16.0 !! phosphate via DIN and Redfield
+#  endif
 		     !!
 		     !! AXY (28/02/14): check input fields
@@ -571,7 +1070,28 @@
                         ji, ',', jj, ',', jk, ') at time', kt
                      endif
+                     !!
+                     !! blank input variables not used at this stage (they relate to air-sea flux)
+                     f_kw660 = 1.0
+                     f_pp0   = 1.0
+                     !!
                      !! calculate carbonate chemistry at grid cell midpoint
-                     CALL trc_co2_medusa( ztmp, zsal, zdic, zalk, fdep2, 5.0, f_pco2a, &    ! inputs
-                     f_ph, f_pco2w, f_h2co3, f_hco3, f_co3, f_omcal(ji,jj),            &    ! outputs
+#  if defined key_mocsy
+                     !! AXY (22/06/15): use Orr & Epitalon (2015) MOCSY-2 carbonate
+                     !!                 chemistry package
+                     CALL mocsy_interface( ztmp, zsal, zalk, zdic, zsil, zpho,         &    ! inputs
+                     f_pp0, fdep2, flatx, f_kw660, f_pco2a, 1,                         &    ! inputs
+                     f_ph, f_pco2w, f_fco2w, f_h2co3, f_hco3, f_co3, f_omarg(ji,jj),   &    ! outputs
+                     f_omcal(ji,jj), f_BetaD, f_rhosw, f_opres, f_insitut,             &    ! outputs
+                     f_pco2atm, f_fco2atm, f_schmidtco2, f_kwco2, f_K0,                &    ! outputs
+                     f_co2starair, f_co2flux, f_dpco2 )                                     ! outputs
+                     !!
+                     f_TDIC = (zdic / f_rhosw) * 1000. ! mmol / m3 -> umol / kg
+                     f_TALK = (zalk / f_rhosw) * 1000. !  meq / m3 ->  ueq / kg
+                     f_dcf  = f_rhosw
+#  else
+                     !! AXY (22/06/15): use old PML carbonate chemistry package (the
+                     !!                 MEDUSA-2 default)
+                     CALL trc_co2_medusa( ztmp, zsal, zdic, zalk, fdep2, f_kw660,      &    ! inputs
+                     f_pco2a, f_ph, f_pco2w, f_h2co3, f_hco3, f_co3, f_omcal(ji,jj),   &    ! outputs
                      f_omarg(ji,jj), f_co2flux, f_TDIC, f_TALK, f_dcf, f_henry, iters)      ! outputs
                      !! 
@@ -581,4 +1101,6 @@
                         iters, ' AT (', ji, ', ', jj, ', ', jk, ') AT ', kt
                      endif
+#  endif
+                     !!
                      !! store 3D outputs
                      f3_pH(ji,jj,jk)    = f_ph
@@ -588,4 +1110,5 @@
                      f3_omcal(ji,jj,jk) = f_omcal(ji,jj)
                      f3_omarg(ji,jj,jk) = f_omarg(ji,jj)
+                     !!
                      !! CCD calculation: calcite
                      if (i2_omcal(ji,jj) .eq. 0 .and. f_omcal(ji,jj) .lt. 1.0) then
@@ -607,4 +1130,5 @@
                         i2_omcal(ji,jj)   = 1
                      endif
+                     !!
                      !! CCD calculation: aragonite
                      if (i2_omarg(ji,jj) .eq. 0 .and. f_omarg(ji,jj) .lt. 1.0) then
@@ -633,4 +1157,9 @@
 # endif
 
+# if defined key_debug_medusa
+      IF (lwp) write (numout,*) 'trc_bio_medusa: ready for full domain calculations'
+      CALL flush(numout)
+# endif 
+
       !!----------------------------------------------------------------------
       !! MEDUSA has unified equation through the water column
@@ -656,5 +1185,4 @@
             !! OPEN wet point IF..THEN loop
             if (tmask(ji,jj,jk).eq.1) then               
-
                !!======================================================================
                !! SETUP LOCAL GRID CELL
@@ -785,6 +1313,4 @@
                if (idf.eq.1.AND.idfval.eq.1.AND.jk.eq.1) then
                   IF (lwp) write (numout,*) '------------------------------'
-                  IF (lwp) write (numout,*) 'dustmo(1) = ', dustmo(ji,jj,1)
-                  IF (lwp) write (numout,*) 'dustmo(2) = ', dustmo(ji,jj,2)
                   IF (lwp) write (numout,*) 'dust      = ', dust(ji,jj)
                endif
